#!/usr/bin/ruby

# RubyWebServer
# Fichier : WebConnection.rb
# version : 1
# Date cration : 16.09.03
# Date modification : 16.09.03
#
# Description :
# Connection TCP entre le serveur et un client.

require 'constants.rb'
require 'user_settings.rb'
require 'DirList.rb'
require 'Content.rb'
require 'Session.rb'

$crlf = 13.chr + 10.chr #<cr><lf>

class WebConnection

   @@nbThread = 0 #le nombre de thread actif
   #pour limiter le nombre de thread
   #@@mutex = Mutex::new
      
   def WebConnection::getNbThread
      return @@nbThread
   end
   
   def initialize(con)
      t = Thread::start(con){|con| 
         begin
            @@nbThread += 1
            
            #thread de garde, tue le thread si il ne s'est pas termin aprs un certain temps
            #ide  chier :  oublier
=begin
            garde = Thread::start(t, con){|t, con|
               sleep MAX_THREAD_LIFE
               t.kill
               t.join
               con.shutdown
               @@nbThread -= 1
            }
=end
            while true
               client_data = con.recvfrom(2048)

               #si le client ferme la connexion...
               break if client_data[0] == ""

               #FIXME !!!!! :
               #mthode de brute : tant qu'il n'y a pas deux \r\n de suite alors attend de nouvelles donnes
               if (/\r\n\r\n/ =~ client_data[0]) == nil
                  tmp = con.recvfrom(4096)
                  client_data[0] += tmp[0]
               end
               #END FIXME !!!!!
              
               #spare les diffrents ligne de la requte, si le client envoie des donnes alors elles se trouvent dans 'client_data[-1]'
               client_data = client_data[0].split("\r\n")
   
               #client_data[0] contient : [<la mthode (get, post)>, <le fichier/repertoire demand>, <la version du protocole HTTP>]
               client_data[0] = client_data[0].split(/\s+/)

               #cherche le cookie
               cookie = ''
               client_data[1..-1].each{|line|
                  line = line.split(":").map!{|l| l.strip }
                  cookie = line[1] if line[0] == 'Cookie'
               }
               #client_data[0][1].gsub(/\/.*$/, '/'), 
               $SESSION = Session::new(cookie) 
               
               #### EXTRACTION DES PARAMETRES GET & POST
               #extrait les paramtres donnes sous la forme : url?a=1&b=2
               GET.clear
               tmp = client_data[0][1].split('?')
               client_data[0][1] = tmp[0]
               tmp[1].to_s.split('&').each{|var|
                  tmp = var.split('=')
                  GET[tmp[0]] = tmp[1]
               }               
               #extrait les paramtres pass par POST
               if client_data[0][0] == 'POST'
                  POST.clear
                  client_data[-1].to_s.split('&').each{|var|
                     tmp = var.split('=')
                     POST[tmp[0]] = tmp[1]
                  }
               end
               #### FIN EXTRACTION DES PARAMETRES GET & POST
               
               begin
                  filename = ROOT_DIR + client_data[0][1];
                  filename.gsub!('/..', '') #vire la remonter de rep
                                    
                  content = Content::new(filename)
                  content.put(con)
                  
                  #on coupe la connexion si ncessaire
                  break if not content.continue?
                  
               rescue  Exception => e
                  #content = ContentError::new(500).put(con)
                  @@nbThread -= 1
                  con.shutdown
               ensure
                  con.flush
               end       
            end
         
            #garde.kill #tue le garde, il ne sert  plus rien
            #garde.join
                        
         rescue  Exception => e
            #puts e.message
            #puts e.backtrace
            #@@nbThread -= 1
            #con.shutdown
         ensure
            @@nbThread -= 1 
            con.shutdown    
         end
      } 
   end

end
