#!/usr/bin/ruby

# RubyWebServer
# Fichier : WebConnection.rb
# version : 1
# Date cration : 16.09.03
# Date modification : 16.09.03
#
# Description :
# Connection TCP entre le serveur et un client.

require 'constants.rb'
require 'user_settings.rb'
require 'DirList.rb'
require 'Content.rb'
require 'Session.rb'
require 'InHttpMessage.rb'

$crlf = 13.chr + 10.chr #<cr><lf>

class WebConnection

   @@nbThread = 0 #le nombre de thread actif
   #pour limiter le nombre de thread
      
   def WebConnection::getNbThread
      return @@nbThread
   end
   
   def initialize(con)
      #si ya trop  de connexion alors renvois une erreur au client
      if @@nbThread >= MAX_THREADS
         ContentError::new(503).put(con)
         con.flush
         con.shutdown
         return
      end
      t = Thread::start(con){|con|
         begin
            
            @@nbThread += 1
            
            #le nombre de message recut durant une connexion
            nbMess = 0
            
            while nbMess < MAX_NUMBER_OF_HTTP_MESSAGE_ON_THE_SAME_CONNEXION
               #coupe la connection si le client ne rpond pas aprs un certain temps
               break if IO::select([con], nil, nil, MAX_CONNEXION_WAIT) == nil
               client_data = con.recvfrom(2048)
               nbMess += 1
                              
               #FIXME !!!!! :
               #mthode de brute : tant qu'il n'y a pas deux \r\n de suite alors attend de nouvelles donnes
               if (/\r\n\r\n/ =~ client_data[0]) == nil
                  tmp = con.recvfrom(2048)
                  client_data[0] += tmp[0]
               end
               #END FIXME !!!!!
               
               messageClient = InHttpMessage::new(client_data, con)
               
               $SESSION = Session::new(messageClient.getOption('Cookie')) 
                              
               content = Content::new(messageClient.getFilename)
               content.setNbMess(nbMess)
               content.put(con)
               
               #on coupe la connexion si ncessaire
               break if not content.continue? or con.closed?

               con.flush     
            end
            
         rescue  Exception => e
            puts e.message
            puts e.backtrace
         ensure         
            @@nbThread -= 1             
            con.shutdown    
         end
      } 
   end

end
