#!/usr/bin/ruby

# EliseWebServer
# Fichier : WebServer.rb
# version : 1
# Date cration : 16.09.03
# Date modification : 8.02.05
#
# Attends qu'une nouvelle connexion soit effectue.

module Kernel
   #mmorise les fichiers inclus par les applications/scripts
   #{ <name> => <load file>, .. }
   @@loaded_files = Hash::new
   def require(f)
      complete_path = Dir::pwd + '/' + f
      if File::exist?(complete_path)
         if nil != loaded_file = @@loaded_files[complete_path]
            if (new_time = File::mtime(complete_path)) != loaded_file
               puts "rechargement de : #{complete_path}"
               Kernel::load(complete_path)
               @@loaded_files[complete_path] = new_time
            end
         else
            Kernel::require(complete_path)
            @@loaded_files[complete_path] = File::mtime(complete_path)
         end
      else
         @@loaded_files.delete(complete_path)
         Kernel::require(f)
      end
   end
end

require 'user_settings.rb'

require 'socket'
require 'thread'

require 'src/WebConnection.rb'

class WebServer
   def start
   
      #coute sur un port
      server = TCPserver::open(LISTEN_PORT)
      
      #cre une "WebConnection" pour chaque nouvelle connexion
      while true         
         WebConnection::new(server.accept)
       end
   end
end
