#!/usr/bin/ruby

# EliseWebServer
# Fichier : constants.rb
# version : 1
# Date cration : 21.06.04
# Date modification : 9.02.05
#
# Constantes du progamme, ne peuvent pas tre modifies par un utilisateur.

#la version de RubyWebServer
RWS_VERSION = "0.1"

SERVER_NAME = "Elise Web Server"
SERVER_TAG = "#{SERVER_NAME} #{RWS_VERSION}"
HTTP_VERSION = 'HTTP/1.0'

#le temps maximal qu'un message du client est attendu [s]
MAX_CONNEXION_WAIT = 300

#le nombre de message HTTP maximal que peut recevoir le serveur sur une mme connexion TCP
MAX_NUMBER_OF_HTTP_MESSAGE_ON_THE_SAME_CONNEXION = 100

#le nom du cookie de session
COOKIE_SESSION_NAME = 'SESSION_ID'

#taille du buffer [o] dans le cas d'envoie de fichier excedant CACHE_MAX_SIZE_FILE (voir user_settings)
#sinon envoie ligne pas ligne
BIN_FILE_BUFFER = 1_000_000

#type MIME en fonction de l'extension
TYPE_MIME = {
'doc' => 'application/msword',
'dot' => 'application/msword',
'bin' => 'application/octet-stream',
'ogg' => 'application/ogg',
'pdf' => 'application/pdf',
'ps' => 'application/postscript',
'ai' => 'application/postscript',
'eps' => 'application/postscript',
'rar' => 'application/rar',
'rss' => 'application/rss+xml',
'xht' => 'application/xhtml+xml',
'xhtlm' => 'application/xhtml+xml',
'txt' => 'text/plain',
'htm' => 'text/html',
'html' => 'text/html',
'shtml' => 'text/html',
'css' => 'text/css',
'xml' => 'application/xml',
'xsl' => 'application/xml',
'zip' => 'application/zip',
'bmp' => 'image/bmp',
'gif' => 'image/gif',
'jpeg' => 'image/jpeg',
'jpg' => 'image/jpeg',
'jpe' => 'image/jpeg',
'png' => 'image/png',
'mpeg' => 'video/mpeg',
'mpg' => 'video/mpeg',
'mpe' => 'video/mpeg',
'qt' => 'video/quicktime',
'mov' => 'video/quicktime',
'asf' => 'video/x-ms-asf',
'asx' => 'video/x-ms-asf',
'wm' => 'video/x-ms-wm',
'wmv' => 'video/x-ms-wmv',
'wmx' => 'video/x-ms-wmx',
'wvx' => 'video/x-ms-wvx',
'avi' => 'video/x-msvideo'}

MIME_DEFAULT = 'html'

#les codes d'tat :
STATE_CODE = {
#succs
200 => 'OK',
201 => 'Created',
202 => 'Accepted',
204 => 'No Content',
301 => 'Moved Permanently',
302 => 'Moved Temporarily',
304 => 'Not Modified',
400 => 'Bad Request',
401 => 'Unauthorized',
403 => 'Forbidden',
404 => 'Not Found',
#non trouv
500 => 'Internal Server Error',
501 => 'Not Implemented',
502 => 'Bad Gateway',
503 => 'Service Unavailable'}

#squelette des pages propres au serveur
SERVER_PAGE = 
<<STR
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
 <head>
  <title>#{SERVER_NAME}</title>
  <style type="text/css" >
a:link {
 color: #0000b0;
 font-family: verdana, arial;
 text-decoration: none;
}
a:visited {
 color: #0000b0;
 font-family: verdana, arial;
 text-decoration: none;
}
a:hover {
 color: #8989ff;
 font-family: verdana, arial;
 text-decoration: underline;
}
a:active {
 color: #ffffff;
 font-family: verdana, arial;
 text-decoration: none;
}
hr {
 border-right: # 0px solid;
 border-top: #ffcece 1px dotted;
 border-left: #ffcece 0px solid;
 border-bottom: #ffcece 0px solid;
 color: white;
}
h2 {
 font-size: 13pt;
 font-family: verdana;
 margin-bottom: 5pt;
}
body {
 border-right: 0px;
 border-top: 0px;
 font-size: 8pt;
 border-left: 0px;
 color: #9F0000;
 border-bottom: 0px;
 font-family: verdana, arial;
 background-color: #f7f7f7;
 text-align: left;
 text-decoration: none
}
  </style>
 </head>
 <body>
  <h2>#{SERVER_NAME}</h2>
  <hr>
  {content}
  <hr>#{SERVER_TAG} by Pifou
 </body>
</html>
STR
