# Module d'accs  une base de donnes grant les multis connexions (multithread)
# date : 12.04.05
# auteur : G.Burri

#sous unix
$LOAD_PATH << '/usr/local/lib/ruby/gems/1.8/gems/postgres-pr-0.4.0/lib'

#sous windaube
#$LOAD_PATH << 'C:\\ruby\\lib\\ruby\\gems\\1.8\\gems\\postgres-pr-0.4.0\\lib'

require 'postgres-pr/connection'

=begin
         #require 'dbi' #un autre driver...
         conn = DBI::connect('DBI:Pg:euphorik', 'postgres', 'Hyperion')
         
         req = conn.prepare('select * from inscrit')
         
         while ligne = req.fetch
            out.puts "#{ligne[0]}, #{ligne[1]}<br/>"
         end

         conn.disconnect
=end

require 'thread'

# Exception leve lorsque il n'y a plus de connexiondisponible
class NoConnectionAvailableException < Exception
end

class Database
   @@NbConnexion = 1

   def Database::setNbConnexion(n)
      @@NbConnexion = n
   end

   def initialize(bd, user, pass, host = nil)
      @cons = Array::new
      
      # ouvre n connexions
      @@NbConnexion.times{
         @cons << PostgresPR::Connection::new(bd, user, pass, host)
      }
      
      @lastResults = Array::new(@@NbConnexion)
      @occupations = Array::new(@@NbConnexion)
      @occupations.fill(false, 0, @@NbConnexion)
      
      @mutex = Mutex::new
   end
   
   #retourne le numero de la requte
   def query(q)
      #recherche une connexion libre
      libre = 0
      @mutex.synchronize{         
         @occupations.each{|o|
            break if o == false
            libre += 1
         }
         raise NoConnectionAvailableException if libre == @@NbConnexion
         #puts "libre = #{libre}"
         @occupations[libre] = true
      }
      @lastResults[libre] = @cons[libre].query(q)
      libre
   end
   
   def eachRow(num)
      @lastResults[num].rows.each{|r|
         yield(r)
      }
   end
   
   def firstRow(num)
      @lastResults[num].rows[0]
   end
   
   def nbRow(num)
      @lastResults[num].rows.size
   end
   
   def freeQuery(num)
      @mutex.synchronize{
         @occupations[num] = false
      }
   end
   
   def beginTrans()
      return query("BEGIN")
   end
   
   def commitTrans(num)
      @con[num].query("COMMIT");
   end

   def close
      @cons.each{|c|
         c.close
      }
   end
end
