# Represente un inscrit
# date : 5.05.05
# auteur : G.Burri

require 'net/smtp'

require 'ek_objet.rb'

class EkInscrit < EkObjet

   #id : l'id dans la bd
   def initialize(id)
      @id = id
   end
   
   def logged?
      @id != nil
   end
   
   #affiche le formulaire pour l'inscription d'un nouveau membre
   def printInscription
      if logged? then return '' end #on ne peut pas s'incrire si on est logg
      form = Formulaire::new('inscription')
      form.addItem(LineEdit::new('Pseudo (login)', 'pseudo', 15, 30))
      form.addItem(LineEdit::new('Password', 'pass1', 15, 10, '', true))
      form.addItem(LineEdit::new('Password (re)', 'pass2', 15, 10, '', true))
      form.addItem(LineEdit::new('E-Mail<br/><h6>un email vous sera envoy<br/> pour confirmer votre inscription</h6>', 'email', 15, 50))
      form.addItem(Submit::new('Inscription'))
      form.getHtml
   end
   
   #affiche un resum
   #nom - grade - status
   def printAbstract
      ret = ''
      num = Euphorik::dbCon.query(
         "SELECT inscrit.pseudo, grade.nom, statut.nom, grade.niveau FROM
          (inscrit INNER JOIN grade ON inscrit.grade = grade.id)
          INNER JOIN statut ON inscrit.statut = statut.id
          WHERE inscrit.id = #{@id}")
      if Euphorik::dbCon.nbRow(num) == 1
         Euphorik::tmpl.setMarkup('user_abstract.html', 'PSEUDO', Euphorik::dbCon.firstRow(num)[0])
         Euphorik::tmpl.setMarkup('user_abstract.html', 'GRADE', Euphorik::dbCon.firstRow(num)[1])
         Euphorik::tmpl.setMarkup('user_abstract.html', 'STATUT', Euphorik::dbCon.firstRow(num)[2])
         
         #les images des grades
         image0 = '<img src="'+Euphorik::tmpl.getVar('user_abstract.html', 'GRADE IMAGE', 'l0')+'" />'
         image1 = '<img src="'+Euphorik::tmpl.getVar('user_abstract.html', 'GRADE IMAGE', 'l1')+'" />'
         image2 = '<img src="'+Euphorik::tmpl.getVar('user_abstract.html', 'GRADE IMAGE', 'l2')+'" />'
         image3 = '<img src="'+Euphorik::tmpl.getVar('user_abstract.html', 'GRADE IMAGE', 'l3')+'" />'
         gradeImage = ''
         level = Euphorik::dbCon.firstRow(num)[3].to_i
         if level <= 10
            gradeImage = image0
         elsif level <= 20
            gradeImage = image1 + '<br/>' + image0
         elsif level <= 40
            gradeImage = image1 + '<br/>' + image2 + '<br/>' + image0
         elsif level <= 50
            gradeImage = image1 + '<br/>' + image1 + '<br/>' + image2 + '<br/>' + image0
         else
            gradeImage = image2 + '<br/>' + image3 + '<br/>' + image0
         end
         Euphorik::tmpl.setMarkup('user_abstract.html', 'GRADE IMAGE', gradeImage)
         
         
         ret = Euphorik::tmpl.process('user_abstract.html')        
      end
      Euphorik::dbCon.freeQuery(num)
      ret
   end
   
   #retourne le pseudo de la personne
   def pseudo
      num = Euphorik::dbCon.query("SELECT pseudo FROM inscrit WHERE id = #{@id}")
      ps = Euphorik::dbCon.firstRow(num)[0]
      Euphorik::dbCon.freeQuery(num)
      return ps
   end
   
   #retourne l'id
   def id
      @id
   end
end
