# Represente la tribune
# date : 5.05.05
# auteur : G.Burri

require 'ek_objet.rb'
require 'ek_erreur.rb'

require 'format.rb'

class EkTribune < EkObjet
   @@NB_MESSAGE = 10
   def initialize(inscrit, input, session)
      @inscrit = inscrit
      @session = session;
   end
   
   def EkTribune::input(input, session, inscrit)
      if input.get('action') == 'tribune_post'
         if !inscrit.logged?
            session.set('error_tribune', 'must_logged')
         elsif input.get('message') == '' or input.get('message') == nil
            session.set('error_tribune', 'message_empty')
         else
            num = Euphorik::dbCon.query("INSERT INTO tribune (inscrit, date, message)
               VALUES (#{inscrit.id}, now(), '#{input.get('message')}')")
            Euphorik::dbCon.freeQuery(num)
         end
      end
   end

   #Retourne l'element sous la forme d'html
   def print
      messages = ''
      
      if @inscrit.logged?
         pseudo = @inscrit.pseudo
      else
         pseudo = ''
      end
      
      num = Euphorik::dbCon.query(
         "SELECT inscrit.pseudo, tribune.date, tribune.message FROM
         tribune INNER JOIN inscrit ON tribune.inscrit = inscrit.id
         ORDER BY tribune.date LIMIT #{@@NB_MESSAGE}")         
      i = 0
      Euphorik::dbCon.eachRow(num){|row|
         Euphorik::tmpl.setMarkup('tribune_message.html', 'PAIR_IMPAIR', i%2 == 0 ? 'pair' : 'impair')
         Euphorik::tmpl.setMarkup('tribune_message.html', 'PSEUDO', row[0])
         Euphorik::tmpl.setMarkup('tribune_message.html', 'DATE', Format::date(row[1]))
         Euphorik::tmpl.setMarkup('tribune_message.html', 'MESSAGE', row[2])
         messages += Euphorik::tmpl.process('tribune_message.html')
         i += 1
      }         
      Euphorik::dbCon.freeQuery(num)
   
      Euphorik::tmpl.setMarkup('tribune.html', 'TRIBUNE MESSAGES', messages)
      
      form = Formulaire::new('tribune_post')
      #form.addItem(LineEdit::new('', 'pseudo', 8, 40, pseudo))
      form.addItem(TextEdit::new('', 'message', 10, 4, '', true))
      form.addItem(Submit::new('post'))
      Euphorik::tmpl.setMarkup('tribune.html', 'TRIBUNE FORMULAIRE',
         case @session.get('error_tribune')
         when 'must_logged' then @session.set('error_tribune', nil); EkErreur::print('vous devez etre logg pour poster sur la tribune')
         when 'message_empty' then @session.set('error_tribune', nil); EkErreur::print('message vide interdit') else '' end +
         form.getHtml)
      return Euphorik::tmpl.process('tribune.html')    
   end
end


