# Construction de formulaire
# date : 8.05.05
# auteur : G.Burri

class Formulaire

   def initialize(action = nil)
      @items = Array::new
      @items << HiddenVal::new('redirect', 'true')
      if action != nil
         @items << HiddenVal::new('action', action)
      end
      @possedeColonneNom = false #si oui alors la premire colonne reprsente les noms de chaque champs
   end
   
   def addItem(item)
      @possedeColonneNom = true if item.getNomAffiche != nil and item.getNomAffiche != ''
      @items << item
   end
      
   def getHtml
      html = '<form method="post" action="main.rb"><table>'
      @items.each {|i|
         html += '<tr>'
         html += '<td>' + i.getNomAffiche + '</td>' if @possedeColonneNom
         html += '<td>' + i.print + '</td>'
         html += '</tr>'
      }
      html += '</table></form>'
      html
   end

end

class FormItem
   def initialize(nom)
      @nomAffiche = nom
   end
   
   def getNomAffiche
      return @nomAffiche
   end

   #mthode virtuelle
   def print
      'Erreur : impossible d\affiche un composant de formulaire'
   end
end

class LineEdit < FormItem
   def initialize(nomAffiche, nom, taille, tailleMax=nil, texte='', password=false)
      super(nomAffiche)
      @nom = nom
      @texte = texte
      @taille = taille
      @tailleMax = tailleMax
      @password = password
   end

   def print
      '<input type="' + ( @password ? 'password' : 'text' ) + '" size="'+@taille.to_s+'" ' + (@tailleMax != nil ? 'maxLength="'+@tailleMax.to_s+'"' : '') +' name="'+@nom+'" value="'+@texte+'" />'
   end
end


class TextEdit < FormItem
   def initialize(nomAffiche, nom, nbCol, nbLigne, texte='', password=false)
      super(nomAffiche)
      @nom = nom
      @texte = texte
      @nbCol = nbCol
      @nbLigne = nbLigne
      @password = password
   end

   def print
      '<textarea name="'+@nom+'" rows="'+@nbLigne.to_s+'" cols="'+@nbCol.to_s+'">'+@texte+'</textarea>'
   end
end


class HiddenVal < FormItem
   def initialize(nom, val='')
      super('')
      @nom = nom
      @val = val
   end
   
   def print
      '<input type="hidden" name="'+@nom+'" value="'+@val+'" />'
   end
end

class Submit < FormItem
   def initialize(nom)
      super('')
      @nom = nom
   end
   
   def print
      '<input type="submit" value="'+@nom+'" />'
   end
end

class CustomWidget < FormItem
   def initialize(nomAffiche, html)
      super(nomAffiche)
      @html = html
   end
   
   def print
      @html
   end
end
