# Guilde euphorik, point d'entre : Euphorik::entryPoint()
# date : 7.02.05
# auteur : G.Burri

require 'database.rb'
Database::setNbConnexion(10)

require 'ek_login.rb'
require 'ek_tribune.rb'

class Euphorik
   
   @@conn = Database::new('euphorikkrew', 'postgres', 'Hyperion')
   @@template = nil
   
public   
   
   def Euphorik::entryPoint(out, input, session)
      begin
         #la partie du login
         login = EkLogin::new(session)
         
         #reception de donnes de formulaires
         if input.get('redirect') == 'true'
            EkLogin::input(input, session)
            EkTribune::input(input, session, login.inscrit)
            return 301
         end
      
         temps = Time::new #pour mesurer le temps de gnration de la page
         
         #si le template n'existe pas dj dans la session alors en cre un nouveau
         if nil == @@template = session.get('template')
            session.set('template', @@template = Template::new(TEMPLATE_DEFAULT_DIRECTORY))
         end
         
         #la tribune
         tribune = EkTribune::new(login.inscrit, input, session)
         
         @@template.setMarkup('index.html', 'TRIBUNE', tribune.print)
         @@template.setMarkup('index.html', 'LOGIN', login.print)
         
         menu = [['forum', 'Forum'], ['news', 'News'], ['articles', 'Articles'], ['bourse', 'Bourse d\'change'], ['agenda', 'Agenda'], ['screens', 'Screens'], ['membres', 'Membres']]
         menuHtml = '| '
         menu.each{|page|
            menuHtml += '<a href="main.rb?p='+page[0]+'" >'+page[1]+'</a>' + ' | '
         }
         @@template.setMarkup('index.html', 'MAIN MENU', menuHtml)
         
         
         #Le contenu principal
         case input.get('p')
         when 'inscription'
            @@template.setMarkup('index.html', 'CONTENU', login.inscrit.printInscription)
         end
         
         out.puts @@template.process('index.html')
         out.puts "page gnre en #{(Time::new - temps)*1000}ms"
      
      rescue NoConnectionAvailableException => e
         out.puts "Trop de connexion  la base de donnes..."
                  
      rescue Exception => e
        out.puts e.backtrace
        out.puts '-----'
        out.puts e.message
      end
   end
   
   #renvois la connexion  la bd
   def Euphorik::dbCon
      return @@conn
   end
   
   #renvois le template
   def Euphorik::tmpl
      return @@template
   end


end
