#!/usr/bin/ruby

# RubyWebServer
# Fichier : inHttpMessage.rb
# version : 1
# Date cration : 3.02.05
# Date modification : 3.02.05
#
# Description :
# Analyse un message HTTP provenant du client.

class InHttpMessage
   @filename
   @options
   def initialize(client_data, con)
      @options = Hash::new

      #spare les diffrents ligne de la requte, si le client envoie des donnes alors elles se trouvent dans 'client_data[-1]'
      client_data = client_data[0].split("\r\n")

      #client_data[0] contient : [<la mthode (get, post)>, <le fichier/repertoire demand>, <la version du protocole HTTP>]
      client_data[0] = client_data[0].split(/\s+/)

      #construit un hash de type : { <option> => <valeur> }
      #si le message est de type 'POST' alors ne lit pas les donnes (-1)
      client_data[1..(client_data[0][0] == 'GET' ? -1 : -3)].each{|line|
         line = line.split(":").map!{|l| l.strip }
         @options[line[0]] = line[1]
      }
      
      #p client_data[-1]
      #si de type 'POST' alors on s'assure d'avoir lut toute les donnes
=begin
      if client_data[0][0] == 'POST'
         length = @options['Content-Length'].to_i
         while client_data[-1].size != length
         
            
            tmp = con.recvfrom(4096)
            client_data[-1] += tmp[0]
            
            puts client_data[-1].size.to_s + " != "  +  length.to_s
         end
      end
=end

      
      #### EXTRACTION DES PARAMETRES GET & POST
      #extrait les paramtres donnes sous la forme : url?a=1&b=2
      GET.clear
      tmp = client_data[0][1].split('?')
      client_data[0][1] = tmp[0]
      tmp[1].to_s.split('&').each{|var|
         tmp = var.split('=')
         GET[tmp[0]] = tmp[1]
      }               
      #extrait les paramtres pass par POST
      if client_data[0][0] == 'POST'
         POST.clear
         client_data[-1].to_s.split('&').each{|var|
            tmp = var.split('=')
            POST[tmp[0]] = tmp[1]
         }
      end
      #### FIN EXTRACTION DES PARAMETRES GET & POST
      
      @filename = ROOT_DIR + client_data[0][1];
      @filename.gsub!('/..', '') #vire la remonter de rep
   end
   
   #renvoie la valeur de l'option demande, nil si elle n'existe pas   
   def getOption(optionName)
      @options[optionName]
   end
   
   #Renvoie la ressource demande
   def getFilename
      @filename
   end
end
