#!/usr/bin/ruby

# RubyWebServer
# Fichier : constants.rb
# version : 1
# Date cration : 21.06.04
# Date modification : 21.08.04
#
# Description :
# Constantes du progamme, ne peuvent tre modifi par un utilisateur.

SERVER_TAG = 'RubyWebServer'
HTTP_VERSION = 'HTTP/1.0'

RWS_VERSION = 0.3

#le temps maximal qu'un message du client est attendu [s]
MAX_CONNEXION_WAIT = 20

#le nombre de message HTTP maximal que peut recevoir le serveur sur une mme connexion TCP
MAX_NUMBER_OF_HTTP_MESSAGE_ON_THE_SAME_CONNEXION = 100

#les deux variables contenant les variables passes au serveur
GET = Hash::new
POST = Hash::new

#le nom du cookie de session
COOKIE_SESSION_NAME = 'SESSION_ID'

#taille du buffer dans le cas d'envois de fichier binaire
#sinon envois ligne pas ligne
BIN_FILE_BUFFER = 1_000_000

#les entits HTML
HTML_ENTITY = {
'%20' => ' '
}

#type en fonction de l'extension
TYPE_MIME = {
'doc' => 'application/msword',
'dot' => 'application/msword',            
'bin' => 'application/octet-stream',
'ogg' => 'application/ogg',
'pdf' => 'application/pdf',
'ps' => 'application/postscript',
'ai' => 'application/postscript',
'eps' => 'application/postscript',
'rar' => 'application/rar',
'rss' => 'application/rss+xml',
'xht' => 'application/xhtml+xml',
'xhtlm' => 'application/xhtml+xml',
'txt' => 'text/plain',
'htm' => 'text/html',
'html' => 'text/html',
'shtml' => 'text/html',
'xml' => 'application/xml',
'xsl' => 'application/xml',
'zip' => 'application/zip',
'gif' => 'image/gif',      
'jpeg' => 'image/jpeg',
'jpg' => 'image/jpeg', 
'jpe' => 'image/jpeg',
'png' => 'image/png',
'mpeg' => 'video/mpeg',
'mpg' => 'video/mpeg',
'mpe' => 'video/mpeg',
'qt' => 'video/quicktime',
'mov' => 'video/quicktime', 
'asf' => 'video/x-ms-asf',
'asx' => 'video/x-ms-asf',
'wm' => 'video/x-ms-wm',
'wmv' => 'video/x-ms-wmv',
'wmx' => 'video/x-ms-wmx',
'wvx' => 'video/x-ms-wvx',
'avi' => 'video/x-msvideo'}
MIME_DEFAULT = 'html'

#Les codes d'tat :
STATE_CODE = {
#succs
200 => 'OK',
201 => 'Created',
202 => 'Accepted',
204 => 'No Content',
301 => 'Moved Permanently',
302 => 'Moved Temporarily',
304 => 'Not Modified',
400 => 'Bad Request',
401 => 'Unauthorized',
403 => 'Forbidden',
404 => 'Not Found',
#non trouv
500 => 'Internal Server Error',
501 => 'Not Implemented',
502 => 'Bad Gateway',
503 => 'Service Unavailable'}


#squelette des pages propres au serveur
SERVER_PAGE = "
<html>
 <head>
  <title>RubyWebServer</title>
 </head>
 <body>
  <h2>RubyWebServer</h2>
  <hr>
  {content}
  <hr>
  RubyWebServer #{RWS_VERSION} by Pifou
 </body>
</html>"
