#!/usr/bin/ruby

# EliseWebServer
# Fichier : HTTPDate.rb
# version : 1
# Date cration : 8.02.05
# Date modification : 8.02.05
#
# Permet de gnrer et de lire une date dans le format de l'option HTTP.

class HTTPTime < Time

   @@DAYS = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat']
   @@MONTHS = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']
   @@MONTHS_REVERSE = {'Jan' => 1, 'Feb' => 2, 'Mar' => 3, 'Apr' => 4, 'May' => 5, 'Jun' => 6, 'Jul' => 7, 'Aug' => 8, 'Sep' => 9, 'Oct' => 10, 'Nov' => 11, 'Dec' => 12}

   def HTTPTime::HTTP(date)
      #             le jour       le mois      l'anne      l'heure (hh:mm:ss)
      /\S+\s+(\d+)\s+(\S+)\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)/ =~ date
      HTTPTime::gm($3.to_i, @@MONTHS_REVERSE[$2], $1.to_i, $4.to_i, $5.to_i, $6.to_i)
   end
   
   def HTTPTime::fromTime(time)
      HTTPTime::local(time.year, time.mon, time.day, time.hour, time.min, time.sec)
   end
   
   def getHTTP
      self.utc
      "#{@@DAYS[self.wday]}, #{(self.day<=9?"0":"")+self.day.to_s} #{@@MONTHS[self.mon-1]} #{self.year.to_s} #{(self.hour<=9?"0":"")+self.hour.to_s}:#{(self.min<=9?"0":"")+self.min.to_s}:#{(self.sec<=9?"0":"")+self.sec.to_s} GMT"
   end
   
   def getHTTPcookie
      self.utc
      "#{@@DAYS[self.wday]}, #{(self.day<=9?"0":"")+self.day.to_s}-#{@@MONTHS[self.mon-1]}-#{self.year.to_s} #{(self.hour<=9?"0":"")+self.hour.to_s}:#{(self.min<=9?"0":"")+self.min.to_s}:#{(self.sec<=9?"0":"")+self.sec.to_s} GMT"
   end
   
end
