#!/usr/bin/ruby

# EliseWebServer
# Fichier : HTTPDate.rb
# version : 1
# Date cration : 10.02.05
# Date modification : 10.02.05
#
# Reprsente des donnes envoye par le client.

class Input
   def initialize
      #les donnes
      # { <nom> => [ <data>, { <attribut> => <valeur attribut> } ]
      @data = Hash::new
   end
   
   def each
      @data.each{|name, data|
         yield(name, data[0])
      }
   end

   # Dfinit une variable d'entre.
   # name String : le nom
   # value Object : la valeur
   def set(name, value)
      @data[name] = [value]
   end

   # Renvoie la valeur en fonction du nom de la donne
   def get(name)
      return @data[name][0] if @data.has_key?(name)
      nil
   end
   
   # Est-ce qu'une variable existe ?
   # name String : le nom de la variablei
   # ret : true si elle existe sinon false
   def exist?(name)
      return @data.has_key?(name)
   end

   # Ajoute un attribut supplmentaire  une variable d'entre.
   # name String : le nom de la variable
   # attributName String : le nom de l'attribut
   # attributValue Object : la valeur de l'attribut
   def add(name, attributName, attributValue)
      @data[name].push({ attributName => attributValue })
   end

   # Renvoie les eventuels attributs supplmentaire
   # (par exemple pour une image envoye par formulaire elle aura l'attribut 'filename').
   # name : le nom de la variable.
   # ret { <attribut> => <valeur attribut>, .. } : les attributs
   def getAttributs(name)
      return @data[name][1] if @data.has_key?(name)
      nil
   end
end
