#!/usr/bin/ruby

# EliseWebServer
# Fichier : user_settings.rb
# version : 1
# Date cration : 21.08.04
# Date modification : 21.08.04
#
# Paramtre dfinit pas l'utilisateur

#le rpertoire de base du serveur web
#(la lettre du lecteur doit tre en majuscule sous MS.Windows)
ROOT_DIR = '/var/www'

#le repertoires pour les serveurs virtuels
# { <address> => <path>, .. }
VIRTUAL_SERVERS = {
}

#gestion des templates
#si ne trouve pas un fichier alors regarde si un template est dfinie :
# par exemple si http://site/style.css n'est pas trouv alors regarde dans
# http://site/templates/<current_template>/style.css
# <current_template> est dfinie comme variable de session et peut etre modifi
# dans un script
TEMPLATES = true

#le repertoire du template par defaut
TEMPLATE_DEFAULT_DIRECTORY = 'templates/default'

#le port sur lequel coute le serveur
LISTEN_PORT = 80

#la liste des applications
#{ <url> => <class name>, .. }
APPLICATIONS = {
   #exemple :
   #'/index.rb' => :MyClass,   
   '/euphorik2/main.rb' => :Euphorik,
   '/pifou/index.rb' => :Pifou
}

#les droits d'acces des repertoires
#{ <url> => <droit> }
# <droit> := ['NOREAD' | 'NOLIST']
# NOREAD : les fichiers contenu dans le rpertoire ne peuvent pas tre lu
# NOLIST : le rpertoire ne peut pas tre list
ACCESS_RIGHTS = {
   #exemple :
   #'/images/' => ['NOLIST']   
   '/euphorik2/conception/' => ['NOREAD', 'NOLIST'],
   '/euphorik2/images/' => ['NOLIST'],
   '/pifou/images/' => ['NOLIST']
}

#la taille du cache [Mo] (fichiers prchargs en mmoire)
CACHE_SIZE = 50

#la taille maximale des fichiers mis en cache [Mo]
CACHE_MAX_SIZE_FILE = 0.5

#les pages par dfaut
INDEXES = ['index.html', 'index.htm', 'main.rb', 'index.rb', 'index.php', 'main.php']

#les fichiers considrs comme dynamique, dfinit par l'extension
DYNAMIC_FILES = ['rb', 'php']

#le maximum de connexion simultanment
#(si plus de connexion disponible alors envoie un 503 au client)
MAX_THREADS = 100

##### paramtres php #####
PHP_INI_FILE = '/etc/php4/apache/php.ini'