# Represente le login
# date : 5.05.05
# auteur : G.Burri
# date : 5.05.05
# auteur : G.Burri

require 'md5'

require 'ek_objet.rb'
require 'ek_inscrit.rb'

class EkLogin < EkObjet

   def initialize(session, input)
      @session = session
      @input = input
          
      @inscrit = EkInscrit::new(session.get('id_inscrit'), input, session)
   end
   
   def inscrit
      @inscrit
   end

   #Retourne l'element sous la forme d'html
   def print(template)
   
      #si logg alors propose de se dlogger
      if @inscrit.logged?
         form = Formulaire::newFormulaire('logout', 'home', @session){|form|
            form.addItem(Submit::new('logout'))
            form.addValidation(ValidationLogout::new(@session))
         }      
         @inscrit.printAbstract(template) + form.getHtml(@input, template)
         
      #si pas logg alors propose de se logger ou de se rendre sur la page d'inscription
      else
      
         form = Formulaire::newFormulaire('log', 'home', @session){|form|
            form.addItem(LineEdit::new('', 'login', 10, 30))
            form.addItem(LineEdit::new('', 'pass', 10, 10, true))
            form.addItem(Submit::new('login'))
            form.addValidation(ValidationLogin::new(@session))
         }
         
         form.getHtml(@input, template) + '<a href="main.rb?p=inscription">s\'inscrire</a> | <a href="main.rb?p=oublie_pass">passe oubli</a>'
      end
   end
end

#permet la validation du formulaire de login
class ValidationLogin < Validation

   def initialize(*p)
      super(*p)
   end

   def estValide(form)    
      pass = MD5::new(form.getChamp('pass').getValeur).hexdigest
      login = form.getChamp('login').getValeur
      
      valide = false
      
      num = Euphorik::dbCon.query("SELECT id, validation, ferme FROM inscrit WHERE pseudo = '#{login}' AND pass = '#{pass}'")
      if Euphorik::dbCon.nbRow(num) == 1
         #est-ce que le compte a t valid ?
         if Euphorik::dbCon.firstRow(num)[1] != 't'
            setErreur('votre compte n\'a pas encore t valid')
         elsif Euphorik::dbCon.firstRow(num)[2] == 't' #est-ce que le compte est ferm ?  
            setErreur('votre compte est ferm')
         else
            @idInscrit = Euphorik::dbCon.firstRow(num)[0].to_i
            @session.set('id_inscrit', @idInscrit)
            valide = true
         end
      else
         setErreur('mauvais login ou pass')
      end
      Euphorik::dbCon.freeQuery(num)
      return valide
   end
end

class ValidationLogout < Validation
   def estValide(form)
      @session.set('id_inscrit', nil)
      return true
   end
end


