#!/usr/bin/ruby

require 'rexml/document'

require 'login.rb'

require 'liens.rb'
require 'citation.rb'
require 'totala.rb'
require 'menu.rb'

PAGE_DEFAUT = 'liens'

class Pifou

   def Pifou::entryPoint(out, input, session)

      #pour mesurer le temps de gnration de la page
      temps = Time::new

      session.setTimeToLive(60 * 60) #dfinie le temps d'une session (1heure)
      input.set('p', PAGE_DEFAUT) unless input.exist?('p') #fixe la page par dfaut

      Menu::setInput(input)

      login = Login::new(input, session)

      corps = case input.get('p')
         when 'liens'
            Liens::new(login)
         when 'citations'
            Citation::new
         when 'totala'
            TotalA::new
         else
            Rien::new
      end

out.puts <<STR
<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr">
 <head>
  <title>Pifou</title>
  <meta http-equiv="Content-Type" content="text/HTML; charset=iso-8859-1" />
  <link rel="stylesheet" type="text/css" href="style.css" />
 </head>
 <body>

  <div class="titre" >
   <h1 class="bodyTitre" ><img src="images/titre.gif" /></h1>
  </div>

  <div class="menu" >
    #{Menu::getHTML}
  </div>

  <div class="main" >
  <div class="outils" >
   #{login.getFormHTML}
   <a href="http://www.debian.org"><img alt="debian" class="outils_debian" src="images/debian.gif" /></a>
   <div>
    Veuillez viter d'utiliser MS Internet Explorer avec ce site.
   </div>
  </div>
   #{corps.getHTML}
  </div>

  <div class="pied" >
   <p class="piedText" >Powered by #{SERVER_TAG}, page gnre en #{(Time::new - temps)*1000}ms</p>
  </div>

 </body>
</html>
STR
   end
end
