# Represente un inscrit
# date : 5.05.05
# auteur : G.Burri

require 'net/smtp'

require 'ek_objet.rb'

class EkInscrit < EkObjet

   #id : l'id dans la bd
   def initialize(id, input, session)
      #vrifie que le compte soit valid et qu'il ne soit pas ferm
      if id != nil
         num = Euphorik::dbCon.query("SELECT ferme, validation FROM inscrit WHERE ferme = false AND validation = true AND id = " + id.to_s)
         id = nil if Euphorik::dbCon.nbRow(num) == 0
         Euphorik::dbCon.freeQuery(num)
      end
      
      @id = id
      
      @session = session
      @input = input
   end
   
   def logged?
      @id != nil
   end
   
   #affche la liste des membres
   def EkInscrit::printInscrits(template)
      liste = '<table><tr><td>Nom</td><td>Date de cration</td>'
      num = Euphorik::dbCon.query("SELECT id, pseudo, date_creation FROM inscrit WHERE ferme = false AND validation = true ORDER by date_creation")
      nb = Euphorik::dbCon.eachRow(num){|r|
         liste += "<tr><td>#{r[1]}</td><td>#{Format::dateDBI(r[2])}</td></tr>"
      }
      liste += '</table>'
      Euphorik.dbCon.freeQuery(num)
      liste
   end
   
   # Affiche le formulaire d'dition de l'inscrit.
   def printFormulaireEdition(template)
      return '' if !logged?
      
      num = Euphorik::dbCon.query(
         "SELECT pseudo, pass, mail, icq, msn, jabber, site_perso, citation,
         signature, histoire_personnage, pensee_philo, avatar_image, nom, prenom, domicile, lien_personnage
         FROM inscrit WHERE id = " + @id.to_s)
         
      row = Euphorik::dbCon.firstRow(num)
      
      form = Formulaire::newFormulaire('edition_inscrit', 'editer_preference', @session){|form|
         form.addItem(HiddenVal::new('id', @id.to_s))
         
         form.addItem(TitleWidget::new('Base'))
         pseudo = LineEdit::new('Pseudo (login)', 'pseudo', 25, 30)
         pseudo.setValeur(row[0])
         form.addItem(pseudo)
         
         password1 = LineEdit::new('Password', 'pass1', 25, 10, true)
         #password1.setValeur(row[1])
         form.addItem(password1)
         password2 = LineEdit::new('Password', 'pass2', 25, 10, true)
         #password2.setValeur(row[1])
         form.addItem(password2)
         
         email = LineEdit::new('E-Mail', 'email', 25, 50)
         email.setValeur(row[2])
         form.addItem(email)
         
         form.addItem(TitleWidget::new('Contact'))
         
         icq = LineEdit::new('Num ICQ', 'icq', 25, 40)
         icq.setValeur(row[3])
         form.addItem(icq)
         
         msn = LineEdit::new('MSN', 'msn', 25, 40)
         msn.setValeur(row[4])
         form.addItem(msn)
         
         jabber = LineEdit::new('Jabber', 'jabber', 25, 40)
         jabber.setValeur(row[5])
         form.addItem(jabber)
         
         sitePerso = LineEdit::new('Site personnel', 'site_perso', 25, 40)
         sitePerso.setValeur(row[6])
         form.addItem(sitePerso)
         
         form.addItem(TitleWidget::new('Autre'))
         
         citation = TextEdit::new('Citation', 'citation', 25, 4)
         citation.setValeur(row[7])
         form.addItem(citation)
         
         signature = TextEdit::new('Signature', 'signature', 25, 3)
         signature.setValeur(row[8])
         form.addItem(signature)
         
         histoirePerso = TextEdit::new('Histoire du personnage', 'histoire_personnage', 25, 6)
         histoirePerso.setValeur(row[9])
         form.addItem(histoirePerso)
         
         penseePhilo = TextEdit::new('Pense philosophique', 'pensee_philo', 25, 4)
         penseePhilo.setValeur(row[10])
         form.addItem(penseePhilo)
         
         avatar = DataWidget::new('Avatar', 'avatar')
         form.addItem(avatar)
         
         form.addItem(Submit::new('Modifier'))
      }
      form.addValidation(ValidationInscrit::new(@session))
      Euphorik.dbCon.freeQuery(num)
      form.getHtml(@input, template)
   end
  
   #affiche le formulaire pour l'inscription d'un nouveau membre
   def printInscription(template)
      return '' if logged? #on ne peut pas s'incrire si on est logg
      
      form = Formulaire::newFormulaire('inscription', 'inscription_ok', @session){|form|
         
         form.addItem(LineEdit::new('Pseudo (login)', 'pseudo', 15, 30))
         form.addItem(LineEdit::new('Password', 'pass1', 15, 10, true))
         form.addItem(LineEdit::new('Password (re)', 'pass2', 15, 10, true))
         form.addItem(LineEdit::new('E-Mail<br/><h6>un email vous sera envoy<br/> pour confirmer votre inscription</h6>', 'email', 15, 50))

         form.addItem(Submit::new('Inscription'))
      }
      form.addValidation(ValidationInscription::new(@session))
      form.getHtml(@input, template)
   end
   
   #affiche une information sur l'info de l'email
   def printOkInscription(template)
      form = Formulaire::getFormulaire('inscription', @session)
      template.setMarkup('inscription_ok.html', 'EMAIL', form == nil ? '' : form.getChamp('email').getValeur)
      template.process('inscription_ok.html')
   end
   
   #affiche un resum
   #nom - grade - status
   def printAbstract(template)
      ret = ''
      num = Euphorik::dbCon.query(
         "SELECT inscrit.pseudo, grade.nom, statut.nom, grade.niveau FROM
          (inscrit INNER JOIN grade ON inscrit.grade = grade.id)
          INNER JOIN statut ON inscrit.statut = statut.id
          WHERE inscrit.id = #{@id}")
          
      if Euphorik::dbCon.nbRow(num) == 1
         template.setMarkup('user_abstract.html', 'PSEUDO', Euphorik::dbCon.firstRow(num)[0])
         template.setMarkup('user_abstract.html', 'GRADE', Euphorik::dbCon.firstRow(num)[1])
         template.setMarkup('user_abstract.html', 'STATUT', Euphorik::dbCon.firstRow(num)[2])
         
         #les images des grades
         image0 = '<img src="'+template.getVar('user_abstract.html', 'GRADE IMAGE', 'l0')+'" />'
         image1 = '<img src="'+template.getVar('user_abstract.html', 'GRADE IMAGE', 'l1')+'" />'
         image2 = '<img src="'+template.getVar('user_abstract.html', 'GRADE IMAGE', 'l2')+'" />'
         image3 = '<img src="'+template.getVar('user_abstract.html', 'GRADE IMAGE', 'l3')+'" />'
         gradeImage = ''
         level = Euphorik::dbCon.firstRow(num)[3].to_i
         if level <= 10
            gradeImage = image0
         elsif level <= 20
            gradeImage = image1 + '<br/>' + image0
         elsif level <= 40
            gradeImage = image1 + '<br/>' + image2 + '<br/>' + image0
         elsif level <= 50
            gradeImage = image1 + '<br/>' + image1 + '<br/>' + image2 + '<br/>' + image0
         else
            gradeImage = image2 + '<br/>' + image3 + '<br/>' + image0
         end
         template.setMarkup('user_abstract.html', 'GRADE IMAGE', gradeImage)
         
         ret = template.process('user_abstract.html')
      end
      Euphorik::dbCon.freeQuery(num)
      ret
   end
   
   #retourne le pseudo de la personne
   def pseudo
      num = Euphorik::dbCon.query("SELECT pseudo FROM inscrit WHERE id = #{@id}")
      ps = Euphorik::dbCon.firstRow(num)[0]
      Euphorik::dbCon.freeQuery(num)
      return ps
   end
   
   #retourne l'id
   def id
      @id
   end
end

#permet la validation du formulaire d'edition d'inscrit
class ValidationInscrit < Validation
   def initialize(*p)
      super(*p)
   end
   
   def estValide(form)
      #vrifie les donnes
      if form.getChamp('pseudo').getValeur == ''
         setErreur('le pseudo ne peut pas etre vide')
         return false
      #elsif form.getChamp('pass1').getValeur == '' or form.getChamp('pass2').getValeur == ''
      #   setErreur('le mot de passe ne peut pas etre vide')
      #   return false
      elsif form.getChamp('pass1').getValeur !=  form.getChamp('pass2').getValeur
         setErreur('les deux mots de passe ne sont pas identiques')
         return false
      elsif form.getChamp('pass1').getValeur != '' && form.getChamp('pass1').getValeur.size < 6
         setErreur('le mot de passe doit contenire au moins six caractres')
         return false
      elsif (/\S+@\S+\.\S+/ =~ form.getChamp('email').getValeur) == nil
         setErreur('l\'adresse E-Mail n\'est pas valide')
         return false
      else
         #vrifie que le pseudo n'existe pas dj
         num = Euphorik::dbCon.query("SELECT count(*) FROM inscrit WHERE id != #{form.getChamp('id').getValeur} AND lower(pseudo) = lower('#{form.getChamp('pseudo').getValeur}')")
         nb = Euphorik::dbCon.firstRow(num)[0].to_i
         Euphorik::dbCon.freeQuery(num)
         if nb > 0
            setErreur('le pseudo est dj utilis par une autre personne')
            return false
         end
      end
                  
      #mmorise les infos dans la base
      #p form.getChamp('avatar').getFilename

      num = Euphorik::dbCon.query("
         UPDATE inscrit SET pseudo = '#{form.getChamp('pseudo').getValeurEsc}' WHERE id = #{form.getChamp('id').getValeurEsc}; " +
         (form.getChamp('pass1').getValeurEsc != '' ? "UPDATE inscrit SET pass = '#{form.getChamp('pass1').getValeurEsc}' WHERE id = #{@id.to_s}; " : '') +
         "UPDATE inscrit SET mail = '#{form.getChamp('email').getValeurEsc}' WHERE id = #{form.getChamp('id').getValeurEsc}; " +
         (form.getChamp('avatar').getFilename != nil ? "UPDATE inscrit SET avatar_image = ? WHERE id = #{form.getChamp('id').getValeurEsc}; " : '') +
         "",
         (form.getChamp('avatar').getFilename != nil ?
            form.getChamp('avatar').getValeur :
            nil
         )         
      )
      
      Euphorik::dbCon.freeQuery(num)

      setMessage('Les donnes ont t mise  jour')

      return true
   end
end

#permet la validation du formulaire d'inscription
class ValidationInscription < Validation

   def initialize(*p)
      super(*p)
   end

   def estValide(form)   
      #vrifie les donnes
      if form.getChamp('pseudo').getValeur == ''
         setErreur('le pseudo ne peut pas etre vide')
         return false
      elsif form.getChamp('pass1').getValeur == '' or form.getChamp('pass2').getValeur == ''
         setErreur('le mot de passe ne peut pas etre vide')
         return false
      elsif form.getChamp('pass1').getValeur !=  form.getChamp('pass2').getValeur
         setErreur('les deux mots de passe ne sont pas identiques')
         return false
      elsif form.getChamp('pass1').getValeur.size < 6
         setErreur('le mot de passe doit contenire au moins six caractres')
         return false
      elsif (/\S+@\S+\.\S+/ =~ form.getChamp('email').getValeur) == nil
         setErreur('l\'adresse E-Mail n\'est pas valide')
         return false
      else
         #vrifie que le pseudo n'existe pas dj
         num = Euphorik::dbCon.query("SELECT count(*) FROM inscrit WHERE lower(pseudo) = lower('#{form.getChamp('pseudo').getValeur}')")
         nb = Euphorik::dbCon.firstRow(num)[0].to_i
         Euphorik::dbCon.freeQuery(num)
         if nb > 0
            setErreur('le pseudo est dj utilis par une autre personne')
            return false
         end
      end
      
      return true
   end
end


