# Represente la tribune
# date : 5.05.05
# auteur : G.Burri

require 'ek_objet.rb'
require 'ek_erreur.rb'

require 'format.rb'

class EkTribune < EkObjet
   @@NB_MESSAGE = 10
   def initialize(inscrit, input, session)
      @inscrit = inscrit
      @session = session
      @input = input
   end
   
   #Retourne l'element sous la forme d'html
   def print(template)
      messages = ''
      
      if @inscrit.logged?
         pseudo = @inscrit.pseudo
      else
         pseudo = ''
      end
      
      num = Euphorik::dbCon.query(
         "SELECT inscrit.pseudo, tribune.date, tribune.message FROM
         tribune INNER JOIN inscrit ON tribune.inscrit = inscrit.id
         ORDER BY tribune.date DESC LIMIT #{@@NB_MESSAGE}")         
      i = 0
      Euphorik::dbCon.rEachRow(num){|row|
         template.setMarkup('tribune_message.html', 'PAIR_IMPAIR', i%2 == 0 ? 'pair' : 'impair')
         template.setMarkup('tribune_message.html', 'PSEUDO', row[0])
         template.setMarkup('tribune_message.html', 'DATE', Format::dateDBI(row[1]))
         template.setMarkup('tribune_message.html', 'MESSAGE', row[2])
         messages += template.process('tribune_message.html')
         i += 1
      }         
      Euphorik::dbCon.freeQuery(num)
   
      template.setMarkup('tribune.html', 'TRIBUNE MESSAGES', messages)
      
      form = Formulaire::newFormulaire('tribune', @input.get('p'), @session){|form|
         form.addItem(TextEdit::new('', 'message', 10, 4))
         form.addItem(Submit::new('post'))
      }  
      form.addValidation(ValidationTribune::new(@inscrit, @session))
            
      template.setMarkup('tribune.html', 'TRIBUNE FORMULAIRE', form.getHtml(@input, template))
      return template.process('tribune.html')    
   end
end

#permet la validation du formulaire de la tribune
class ValidationTribune < Validation

   def initialize(inscrit, *p)
      super(*p)
      @inscrit = inscrit
   end

   def estValide(form)
      if !@inscrit.logged?
         setErreur('vous devez etre logg pour poster sur la tribune')
         return false
      elsif form.getChamp('message').getValeur == ''
         setErreur('message vide interdit')
         return false
      else
         num = Euphorik::dbCon.query("INSERT INTO tribune (inscrit, date, message)
            VALUES (#{@inscrit.id}, now(), '#{form.getChamp('message').getValeur}')")
         Euphorik::dbCon.freeQuery(num)
         return true
      end
   end
end




