# Guilde euphorik, point d'entre : Euphorik::entryPoint()
# date : 7.02.05
# auteur : G.Burri

require 'database.rb'
Database::setNbConnexion(10)

require 'ek_login.rb'
require 'ek_tribune.rb'
require 'ek_menu.rb'
require 'ek_gestion.rb'

class Euphorik
   
   @@conn = Database::new('euphorikkrew', 'postgres', 'Hyperion')
      
   def Euphorik::entryPoint(out, input, session)
      begin
         temps = Time::new #pour mesurer le temps de gnration de la page
         
         #indentification de la personne
         login = EkLogin::new(session, input)
         
         ###### reception de donnes de formulaires ######
         if input.get('redirect') == 'true'
            if nil != p = input.get('p')
               session.set('p', p)
            end
            Formulaire::input(input, session)
            return 301 #redirection
         end
         
         #si la page n'est pas dfinit
         if input.get('p') == nil
            #si on a une information dans le session de la page  afficher
            if nil != p = session.get('p')
               input.set('p', p)
            else #page par dfaut
               input.set('p', 'home')
            end
         end
         
         #debug
         puts "page = " + input.get('p')
         
         #si le template n'existe pas dj dans la session alors en cre un nouveau
         if nil == template = session.get('template')
            session.set('template', template = Template::new(TEMPLATE_DEFAULT_DIRECTORY))
         end
         
         #la tribune
         tribune = EkTribune::new(login.inscrit, input, session)
         template.setMarkup('index.html', 'TRIBUNE', tribune.print(template))
         template.setMarkup('index.html', 'LOGIN', login.print(template))
         
         #le menu
         menu = EkMenu::new
         template.setMarkup('index.html', 'MAIN MENU', menu.print)  
         
         #les operations de gestion (ajout d'informations, edition des prfrences, messages privs, etc..)
         operations = EkGestion::new(login.inscrit)
         template.setMarkup('index.html', 'GESTION', operations.print(template))
         
         #Le contenu principal
         case input.get('p')
            when 'home'
               template.setMarkup('index.html', 'CONTENU', 'home')
            when 'inscription'
               template.setMarkup('index.html', 'CONTENU', login.inscrit.printInscription(template))
            when 'inscription_ok'
               template.setMarkup('index.html', 'CONTENU', login.inscrit.printOkInscription(template))
            when 'membres'
               template.setMarkup('index.html', 'CONTENU', EkInscrit::printInscrits(template))
            when 'editer_preference'
               template.setMarkup('index.html', 'CONTENU', login.inscrit.printFormulaireEdition(template))
            else
               template.setMarkup('index.html', 'CONTENU', EkErreur::print('Erreur : page inconnue', template))
         end         
         
         out.puts template.process('index.html')
         out.puts "page gnre en #{(Time::new - temps)*1000}ms"
      
      rescue NoConnectionAvailableException => e
         out.puts "Trop de connexion  la base de donnes..."
                  
      rescue Exception => e
        
         out.puts '<b>' + e.message + '</b><br/>'
        
         e.backtrace.each{|f|
            out.puts f + '<br/>'
         }
      end
   end
   
   #renvoie la connexion  la bd
   def Euphorik::dbCon
      return @@conn
   end
      
end
